#include <iostream>
using namespace std;
int main () {
    int n,x[2000],y[2000],big=0;
    cin>>n;
    for(int i=0;i<n;i++) {
        cin>>x[i]>>y[i];
        for(int j=0;j<i;j++) {
                int s;
            if(x[i]==x[j]) {
                s=abs(y[i]-y[j]);
            }
            if(y[i]==y[j]) {
                s=abs(x[i]-x[j]);
            }
            if(s>big) {
                big=s;
            }
        }
    }
    cout<<big;
    return 0;
}
